using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_function")]
    public class SecurityFunctionEntity : EntityBase<string>
    {

    public SecurityFunctionEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("function_name")]
    public string FunctionName  { get; set; }
    [Column("function_local_name")]
    public string? FunctionLocalName  { get; set; }
    [Column("function_eng_name")]
    public string? FunctionEngName  { get; set; }
    [Column("function_indc")]
    public string FunctionIndc  { get; set; }
    [Column("page_url")]
    public string? PageUrl  { get; set; }
    [Column("api_route")]
    public string? ApiRoute  { get; set; }
    [Column("icon")]
    public string? Icon  { get; set; }
    [Column("page_name")]
    public string? PageName  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string FUNCTION_NAME = "FunctionName";
    public const string FUNCTION_LOCAL_NAME = "FunctionLocalName";
    public const string FUNCTION_ENG_NAME = "FunctionEngName";
    public const string FUNCTION_INDC = "FunctionIndc";
    public const string PAGE_URL = "PageUrl";
    public const string API_ROUTE = "ApiRoute";
    public const string ICON = "Icon";
    public const string PAGE_NAME = "PageName";

    public const string DB_NAME_SECURITY_FUNCTION = "security_function";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,function_name,function_local_name,function_eng_name,function_indc,page_url,api_route,icon,page_name";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_FUNCTION_NAME = "function_name";
    public const string DB_FUNCTION_LOCAL_NAME = "function_local_name";
    public const string DB_FUNCTION_ENG_NAME = "function_eng_name";
    public const string DB_FUNCTION_INDC = "function_indc";
    public const string DB_PAGE_URL = "page_url";
    public const string DB_API_ROUTE = "api_route";
    public const string DB_ICON = "icon";
    public const string DB_PAGE_NAME = "page_name";


    public static SecurityFunctionEntity GetInstance()
    {
        return new SecurityFunctionEntity();
    }

    public virtual void CopyFrom(SecurityFunctionEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityFunctionEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.FunctionName =  source.FunctionName;
        this.FunctionLocalName =  source.FunctionLocalName;
        this.FunctionEngName =  source.FunctionEngName;
        this.FunctionIndc =  source.FunctionIndc;
        this.PageUrl =  source.PageUrl;
        this.ApiRoute =  source.ApiRoute;
        this.Icon =  source.Icon;
        this.PageName =  source.PageName;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_FUNCTION}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_FUNCTION}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_FUNCTION_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_FUNCTION}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityFunctionEntity Clone()
    {
        SecurityFunctionEntity result = new SecurityFunctionEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
